function Armor::onCollision(%this,%obj,%col,%vec,%speed)
{
   %client = %obj.client;

   if(%col.Elevator)
   {
	%col.Elevated[%obj.client] = 1;
	%obj.client.currentElevatorObj = %col;
	%obj.client.isElevating = 1;	
   }

   if (%obj.getState() $= "Dead")
      return;

	if (%col.getClassName() $= "Item")
	{
		//echo("calling pickup ", %col.thrower);
		//echo("pickup obj = ", %obj);
		if(%col.thrower != %obj)
		{
			%obj.pickup(%col);
		}
	}
	if (%col.getClassName() $= "Light")
	{
		return;
	}

	if(%col.getClassName() $= "StaticShape")
	{

	if(%col.isDoorbell $= 1 && %obj.client.BellTimeout[%col] !$= 1)
	{
		messageClient(%col.owner,'','\c0%1 \c4rings your Doorbell.', %obj.client.name);
		%obj.client.BellTimeout[%col] = 1;
		schedule(20000,0,"clearBellTimeout",%obj.client, %col);
	}

	if(%col.isImp && %col.isTriggerImp !$= 1)
	{
			%pos = getwords(%col.getTransform(), 0, 2);
			%obj.client.player.applyimpulse(%pos,%col.Imp);
	}


if($Pref::Server::BombRigging $= 1)
{

	if(%col.brickType $= 1)
	{
		if(%col.riggerID.plantedbomb >= 1)
		{
			messageAll('name', '\c0%1\'s\c5 Bomb was Detonated!', %col.RiggerID.name);
			for(%t = 0; %t < MissionCleanup.getCount(); %t++)
			{
				%bomb = MissionCleanup.getObject(%t);
				if(%bomb.brickType $= 2 && %bomb.bombID $= %col.bombID)
				{
					servercmdblowbricks(%client,%bomb);
					%col.RiggerID.plantedbomb = 0;
					%col.RiggerID.plantedplunger = 0;
					%col.dead = true;
					%col.schedule(10, explode);
				}
			}
		}
	}

}


		if(%col.isteleportObjGateway == 1){
			if(%obj.client.NoTeleport == 0){
				%obj.client.isRequestingTeletoID = 1;
				commandtoclient(%client,'OpenPWBox');
		}}
		if(%col.teleportObj > 0)
		{
			if(%obj.client.NoTeleport == 0)
			{
				for(%t = 0; %t < MissionCleanup.getCount(); %t++)
				{
					%teleObj = MissionCleanup.getObject(%t);
					if(%teleObj.teleportObj == %col.teleportObj && %teleObj != %col)
					{
						Schedule(200,0,"ServerCmdTeleportToObj",%client,%teleObj,500);
						break;
					}
				}
				
			}
		}

		testbrick(%obj.client, %col);

}
}


function serverCmdToggleWandMode(%client)
{
	if(%client.isAdmin || %client.isSuperAdmin)
	{
		%client.WandMode++;
		if(%client.WandMode > 8)
		{
			%client.WandMode = 0;
		}

	if(%client.WandMode == 0)
	{
		messageClient(%client,"","\c2Wand in Destroy-Mode");
	}
	if(%client.WandMode == 1)
	{
		messageClient(%client,"","\c2Wand in Teleport-Mode");
	}
	if(%client.WandMode == 2)
	{
		messageClient(%client,"","\c2Wand in Safe-Brick-Mode");
	}
	if(%client.WandMode == 3)
	{
		messageClient(%client,"","\c2Wand in Cloak-Mode");
	}
	if(%client.WandMode == 4)
	{
		messageClient(%client,"","\c2Wand in Jail-Mode");
	}
	if(%client.WandMode == 5)
	{
		messageClient(%client,"","\c2Wand in Destroy-By-Owner-Mode");
	}
	if(%client.WandMode == 6)
	{
		messageClient(%client,"","\c2Wand in Clock-Mode");
	}
	if(%client.WandMode == 7)
	{
		messageClient(%client,"","\c2Wand in Teleport-By-ID-Mode");
	}
	if(%client.WandMode == 8)
	{
		messageClient(%client,"","\c2Wand in Teleport-Gateway-Mode");
	}
	}
}

function wandProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%obj.client.isAdmin || %obj.client.isSuperAdmin || %obj.client.isTempAdmin)
	{ 
		%player = %obj.client.player;

		//if theres no player, (or client) bail out now
		if(!%player)
			return;

		if (%col.getClassName() !$= "StaticShape")
			return;

		%colData = %col.getDataBlock();
		%colDataClass = %colData.classname;
		
		if(%colDataClass $= "brick")
		{
			if(%obj.client.WandMode == 0)
			{
				killBrick(%col);
			}
			if(%obj.client.WandMode == 1)
			{
				if(%col.teleportObj == 0)
				{
				if(%obj.client.teleHits == 0)	
				{
					$Pref::Game::TotalTelePortLinks++;
					%obj.client.teleHits++;
					%col.teleportObj = $Pref::Game::TotalTelePortLinks;
					messageClient(%obj.client,"","\c4Set first teleport link");
				}
				else
				{
					%obj.client.teleHits = 0;
					%col.teleportObj = $Pref::Game::TotalTelePortLinks;
					messageClient(%obj.client,"","\c4Set second teleport link");
					//schedule(500,0,"Telepulse",%col);
				}
				}
				else
				{
					%col.teleportObj = 0;
					messageClient(%obj.client,"","\c4Removed teleport link");
				}
			}
			if(%obj.client.WandMode == 2)
			{
				if(%col.NoDestroy == 0)
				{
					%col.NoDestroy = 1;
					messageClient(%obj.client,"","\c4Made brick safe from deathmatch weapons");
				}
				else
				{
					%col.NoDestroy = 0;
					messageClient(%obj.client,"","\c4Brick is no longer safe from deathmatch weapons");
				}

			}
			if(%obj.client.WandMode == 6)
			{
				CenterPrint(%obj.client,"Created a clock.", 5, 1);
				OrigClockNit(%col);
			}
			if(%obj.client.WandMode == 7)
			{
				if(%col.teleportObjByID == 0)
				{
					%obj.client.isMakingLinkByID = 1;
					%obj.client.RequestedLink = %col;
					messageClient(%obj.client,"","\c4Enter a requested ID number.");
					commandtoclient(%obj.client,'OpenPWBox');
				}
				else
				{
					%col.teleportObj = 0;
					messageClient(%obj.client,"","\c4Removed teleport by ID");
				}
			}
			if(%obj.client.WandMode == 8)
			{
				if(%col.teleportObjGateway == 0)
				{
					%col.isteleportObjGateway = 1;
					messageClient(%obj.client,"","\c4Created a teleport by ID Gateway.");
				}
				else
				{
					%col.teleportObjGateway = 0;
					messageClient(%obj.client,"","\c4Removed a teleport by ID Gateway.");
				}
			}
		}
		if(%obj.client.WandMode == 3)
		{
			if(%col.iswcloaked != 0 && %col.iswcloaked != 1)
			{
				%col.setcloaked(1);
				%col.iswcloaked = 1;
			}
			else if(%col.iswcloaked == 0)
			{
				%col.setcloaked(1);
				%col.iswcloaked = 1;
			}
			else if(%col.iswcloaked == 1)
			{
				%col.setcloaked(0);
				%col.iswcloaked = 0;
			}
		}
		if(%obj.client.WandMode == 4)
		{
			if(%col.isDetBrick $= 1)
			{
				%col.isDetBrick = 0;
				messageClient(%obj.client,"","\c4Removed Jail Spawn.");
			}
			else
			{
			%col.isDetBrick = 1;
			messageClient(%obj.client,"","\c4Assigned Jail Spawn.");
			}
		}


		if(%obj.client.WandMode == 5)
		{
			%owner = %col.ownername;
			%ownerip = %col.ownerip;
			commandtoclient(%obj.client,'openBP',%owner,%ownerip);
		}
	}
}

function serverCmdCheckDoorPassword(%client,%password)
{
	%col = %client.PWDoor;
	if(%client.isMakingLinkByID){
		%client.RequestedLink.LinkedByID = 1;
		%client.RequestedLink.LinkNum = %password;
		%client.isMakingLinkByID = 0;
		centerprint(%client,"ID set to " @ %password @ ".",5,1);
		return;
	}
	if(%client.isRequestingTeletoID){
		for(%t = 0; %t < MissionCleanup.getCount(); %t++){
		%teleObj = MissionCleanup.getObject(%t);
		if(%teleObj.LinkedByID == 1 && %teleObj.LinkNum $= %password){
			Schedule(200,0,"ServerCmdTeleportToObj",%client,%teleObj,500);
			%client.isRequestingTeletoID = 0;
			centerprint(%client,"Teleporting to ID " @ %password @ "...",5,1);
			return;
		}}
		messageClient(%client,"",'\c4Invalid ID!',%password);
		return;
	}
	if(%col.password $= %password || (%client.isSuperAdmin && $Pref::Server::CopsAndRobbers !$= 1))
	{
		centerprint(%client,"Password Accepted!",5,1);
		executemoverinstructions(%client, %col);
	}
	else
	{
		centerprint(%client,"Password Rejected!",5,1);
	}
}